Attribute VB_Name = "Module1"
Private TempObjects As String
Public TempString As String * 50
Public CurrentLevel As Integer
Public ScreenBlocksX As Integer
Public ScreenBlocksY As Integer
Type MapType
    Name As String
    North As String
    South As String
    East As String
    West As String
    Up As String
    Down As String
    Level As Integer
    NumberOfThings As Integer
    WhatsInIt(100) As String
End Type
Type MapBlockType
    x1 As Integer
    x2 As Integer
    y1 As Integer
    y2 As Integer
    Name As String
    Level As Integer
End Type
Public TempColor As Long
Public OldBlockName As String
Public Map(1000) As MapType
Public MapBlock(1000) As MapBlockType
Public CorridorWidth
Public NumberOfRooms As Integer
Public RoomWidth

Sub LoadMapData()
RoomWidth = 10
CorridorWidth = 2
NumberOfRooms = 0
Dim NumberOfObjects As String
Open App.Path & "\map.dat" For Binary As #1
Get #1, , TempString
NumberOfRooms = Val(Trim(TempString))
For r = 1 To NumberOfRooms
Get #1, , TempString
Map(r).Name = Trim(TempString)
Get #1, , TempString
Map(r).North = Trim(TempString)
Get #1, , TempString
Map(r).East = Trim(TempString)
Get #1, , TempString
Map(r).South = Trim(TempString)
Get #1, , TempString
Map(r).West = Trim(TempString)
Get #1, , TempString
Map(r).Up = Trim(TempString)
Get #1, , TempString
Map(r).Down = Trim(TempString)
Get #1, , TempString
Map(r).Level = Val(Trim(TempString))
Get #1, , TempString
Map(r).NumberOfThings = Val(Trim(TempString))
For i = 1 To Val(Map(r).NumberOfThings)
    Get #1, , TempString
    Map(r).WhatsInIt(i) = Trim(TempString)
Next i
Get #1, , TempString
If Trim(TempString) <> "***" Then Exit For
Next r
Close #1
End Sub
Sub ClearBlocks()
For i = 1 To NumberOfRooms
    MapBlock(i).Name = ""
Next i
End Sub
Sub BuildMap()
Dim CurX, CurY As Integer
Dim FreeBlock, InitialFreeBlock As Integer
CurX = ((Form1.ScaleWidth / 2) - (RoomWidth / 2))
CurY = ((Form1.ScaleHeight / 2) - (RoomWidth / 2))
For i = 1 To NumberOfRooms
    InitialFreeBlock = FindFreeBlock
    If FindThisName(Map(i).Name) = False Then
        MapBlock(InitialFreeBlock).x1 = CurX
        MapBlock(InitialFreeBlock).y1 = CurY
        MapBlock(InitialFreeBlock).x2 = MapBlock(i).x1 + RoomWidth
        MapBlock(InitialFreeBlock).y2 = MapBlock(i).y1 + RoomWidth
        MapBlock(InitialFreeBlock).Name = Map(i).Name
        MapBlock(InitialFreeBlock).Level = Map(i).Level
    Else
        InitialFreeBlock = WhereIsThisName(Map(i).Name)
    End If
    
    If Map(i).North <> "None" And FindThisName(Map(i).North) = False Then
        FreeBlock = FindFreeBlock
        CurX = MapBlock(InitialFreeBlock).x1
        CurY = MapBlock(InitialFreeBlock).y1 - (RoomWidth + CorridorWidth)
        MapBlock(FreeBlock).x1 = CurX
        MapBlock(FreeBlock).y1 = CurY
        MapBlock(FreeBlock).x2 = MapBlock(FreeBlock).x1 + RoomWidth
        MapBlock(FreeBlock).y2 = MapBlock(FreeBlock).y1 + RoomWidth
        MapBlock(FreeBlock).Name = Map(i).North
        MapBlock(FreeBlock).Level = Map(WhereIsThisNameMap(MapBlock(FreeBlock).Name)).Level
    End If
    If Map(i).South <> "None" And FindThisName(Map(i).South) = False Then
        FreeBlock = FindFreeBlock
        CurX = MapBlock(InitialFreeBlock).x1
        CurY = MapBlock(InitialFreeBlock).y1 + (RoomWidth + CorridorWidth)
        MapBlock(FreeBlock).x1 = CurX
        MapBlock(FreeBlock).y1 = CurY
        MapBlock(FreeBlock).x2 = MapBlock(FreeBlock).x1 + RoomWidth
        MapBlock(FreeBlock).y2 = MapBlock(FreeBlock).y1 + RoomWidth
        MapBlock(FreeBlock).Name = Map(i).South
        MapBlock(FreeBlock).Level = Map(WhereIsThisNameMap(MapBlock(FreeBlock).Name)).Level
    End If
    If Map(i).East <> "None" And FindThisName(Map(i).East) = False Then
        FreeBlock = FindFreeBlock
        CurX = MapBlock(InitialFreeBlock).x1 + (RoomWidth + CorridorWidth)
        CurY = MapBlock(InitialFreeBlock).y1
        MapBlock(FreeBlock).x1 = CurX
        MapBlock(FreeBlock).y1 = CurY
        MapBlock(FreeBlock).x2 = MapBlock(FreeBlock).x1 + RoomWidth
        MapBlock(FreeBlock).y2 = MapBlock(FreeBlock).y1 + RoomWidth
        MapBlock(FreeBlock).Name = Map(i).East
        MapBlock(FreeBlock).Level = Map(WhereIsThisNameMap(MapBlock(FreeBlock).Name)).Level
    End If
    If Map(i).West <> "None" And FindThisName(Map(i).West) = False Then
        FreeBlock = FindFreeBlock
        CurX = MapBlock(InitialFreeBlock).x1 - (RoomWidth + CorridorWidth)
        CurY = MapBlock(InitialFreeBlock).y1
        MapBlock(FreeBlock).x1 = CurX
        MapBlock(FreeBlock).y1 = CurY
        MapBlock(FreeBlock).x2 = MapBlock(FreeBlock).x1 + RoomWidth
        MapBlock(FreeBlock).y2 = MapBlock(FreeBlock).y1 + RoomWidth
        MapBlock(FreeBlock).Name = Map(i).West
        MapBlock(FreeBlock).Level = Map(WhereIsThisNameMap(MapBlock(FreeBlock).Name)).Level
    End If
    If Map(i).Down <> "None" And FindThisName(Map(i).Down) = False Then
        FreeBlock = FindFreeBlock
        CurX = MapBlock(InitialFreeBlock).x1
        CurY = MapBlock(InitialFreeBlock).y1
        MapBlock(FreeBlock).x1 = CurX
        MapBlock(FreeBlock).y1 = CurY
        MapBlock(FreeBlock).x2 = MapBlock(FreeBlock).x1 + RoomWidth
        MapBlock(FreeBlock).y2 = MapBlock(FreeBlock).y1 + RoomWidth
        MapBlock(FreeBlock).Name = Map(i).Down
        MapBlock(FreeBlock).Level = Map(WhereIsThisNameMap(MapBlock(FreeBlock).Name)).Level
    End If
    If Map(i).Up <> "None" And FindThisName(Map(i).Up) = False Then
        FreeBlock = FindFreeBlock
        CurX = MapBlock(InitialFreeBlock).x1
        CurY = MapBlock(InitialFreeBlock).y1
        MapBlock(FreeBlock).x1 = CurX
        MapBlock(FreeBlock).y1 = CurY
        MapBlock(FreeBlock).x2 = MapBlock(FreeBlock).x1 + RoomWidth
        MapBlock(FreeBlock).y2 = MapBlock(FreeBlock).y1 + RoomWidth
        MapBlock(FreeBlock).Name = Map(i).Up
        MapBlock(FreeBlock).Level = Map(WhereIsThisNameMap(MapBlock(FreeBlock).Name)).Level
    End If

    'Don't Forget To Add Up !!!
Next i
End Sub
Function FindFreeBlock() As Integer
For r = 1 To NumberOfRooms
    If MapBlock(r).Name = "" Then FindFreeBlock = r: Exit Function
Next r
FindFreeBlock = -1 ' Could'nt Find A Free Block
End Function
Function FindThisName(Name As String) As Boolean
For z = 1 To NumberOfRooms
    If MapBlock(z).Name = Name Then FindThisName = True: Exit Function
Next z
FindThisName = False
End Function
Function WhereIsThisName(Name As String) As Integer
For z = 1 To NumberOfRooms
    If MapBlock(z).Name = Name Then WhereIsThisName = z: Exit Function
Next z
WhereIsThisName = -1 'We Didnt Find It
End Function
Function WhereIsThisNameMap(Name As String) As Integer
For z = 1 To NumberOfRooms
    If Map(z).Name = Name Then WhereIsThisNameMap = z: Exit Function
Next z
WhereIsThisNameMap = -1 'We Didnt Find It
End Function

Sub DrawMap()
For i = 1 To NumberOfRooms
    If MapBlock(i).Level = CurrentLevel Then
        Form1.Line (MapBlock(i).x1 + ((RoomWidth + CorridorWidth) * ScreenBlocksX), MapBlock(i).y1 + ((RoomWidth + CorridorWidth) * ScreenBlocksY))-(MapBlock(i).x2 + ((RoomWidth + CorridorWidth) * ScreenBlocksX), MapBlock(i).y2 + ((RoomWidth + CorridorWidth) * ScreenBlocksY)), , B
    End If
Next i
DrawLinkingLines
End Sub

Sub RenderText(pText As String)
Form1.Label1.Caption = pText
End Sub

Function RetrieveName(X, Y) As String
For i = 1 To NumberOfRooms
    If X > MapBlock(i).x1 + (ScreenBlocksX * (RoomWidth + CorridorWidth)) And X < MapBlock(i).x2 + (ScreenBlocksX * (RoomWidth + CorridorWidth)) And Y > MapBlock(i).y1 + (ScreenBlocksY * (RoomWidth + CorridorWidth)) And Y < MapBlock(i).y2 + (ScreenBlocksY * (RoomWidth + CorridorWidth)) And MapBlock(i).Level = CurrentLevel Then
        RetrieveName = MapBlock(i).Name
        Exit Function
    End If
Next i
RetrieveName = "None"
End Function

Function GetObjects(pName As String) As String
TempObjects = ""
Number = WhereIsThisNameMap(pName)
For i = 1 To Map(Number).NumberOfThings
    If UCase(Left(Map(Number).WhatsInIt(i), 1)) = "A" Or UCase(Left(Map(Number).WhatsInIt(i), 1)) = "E" Or UCase(Left(Map(Number).WhatsInIt(i), 1)) = "I" Or UCase(Left(Map(Number).WhatsInIt(i), 1)) = "O" Or UCase(Left(Map(Number).WhatsInIt(i), 1)) = "U" Then
        TempObjects = TempObjects & "An "
    Else
        TempObjects = TempObjects & "A "
    End If
    TempObjects = TempObjects & Map(Number).WhatsInIt(i) & ", "
Next i
If Trim(TempObjects) = "" Then GetObjects = "Nothing": Exit Function
GetObjects = Trim(Left(Trim(TempObjects), Len(Trim(TempObjects)) - 1))
End Function

Sub DrawLinkingLines()
For i = 1 To NumberOfRooms
    If Map(i).North <> "None" Then
        LinkFrom = WhereIsThisName(Map(i).Name)
        LinkTo = WhereIsThisName(Map(i).North)
        If MapBlock(LinkFrom).Level = CurrentLevel Then
            Form1.Line (MapBlock(LinkTo).x1 + ((RoomWidth + CorridorWidth) * ScreenBlocksX) + ((RoomWidth / 2) - (CorridorWidth / 2)), MapBlock(LinkTo).y1 + ((RoomWidth + CorridorWidth) * ScreenBlocksY) + RoomWidth)-((MapBlock(LinkFrom).x1 + ((RoomWidth + CorridorWidth) * ScreenBlocksX) + ((RoomWidth / 2) - (CorridorWidth / 2)) + CorridorWidth), MapBlock(LinkFrom).y1 + ((RoomWidth + CorridorWidth) * ScreenBlocksY)), , B
        End If
    End If
    If Map(i).East <> "None" Then
        LinkFrom = WhereIsThisName(Map(i).Name)
        LinkTo = WhereIsThisName(Map(i).East)
        If MapBlock(LinkFrom).Level = CurrentLevel Then
            Form1.Line (MapBlock(LinkFrom).x2 + ((RoomWidth + CorridorWidth) * ScreenBlocksX), MapBlock(LinkFrom).y1 + ((RoomWidth + CorridorWidth) * ScreenBlocksY) + ((RoomWidth / 2) - (CorridorWidth / 2)))-(MapBlock(LinkTo).x1 + ((RoomWidth + CorridorWidth) * ScreenBlocksX), (MapBlock(LinkTo).y1 + ((RoomWidth + CorridorWidth) * ScreenBlocksY) + ((RoomWidth / 2) - (CorridorWidth / 2))) + CorridorWidth), , B
        End If
    End If
Next i
End Sub
