Attribute VB_Name = "EditorMod"
Type EditorRoomType
    RoomName As String
    NumberInMapArray As Integer
End Type
Type LevelType
    NumberOfRooms As Integer
    Rooms(100) As EditorRoomType
End Type
Public EditorMap(1000) As MapType
Public EditorNumberOfRooms As Integer
Public LevelNumber(-500 To 500) As LevelType
Public Validated As Boolean
Public Ecurrentroom As Integer
Public Ecurrentlevel As Integer
Sub LoadEditorData()
Validated = False
Open App.Path & "\map.dat" For Binary As #1
Get #1, , TempString
EditorNumberOfRooms = Val(Trim(TempString))
For r = 1 To EditorNumberOfRooms
Get #1, , TempString
EditorMap(r).Name = Trim(TempString)
Get #1, , TempString
EditorMap(r).North = Trim(TempString)
Get #1, , TempString
EditorMap(r).East = Trim(TempString)
Get #1, , TempString
EditorMap(r).South = Trim(TempString)
Get #1, , TempString
EditorMap(r).West = Trim(TempString)
Get #1, , TempString
EditorMap(r).Up = Trim(TempString)
Get #1, , TempString
EditorMap(r).Down = Trim(TempString)
Get #1, , TempString
EditorMap(r).Level = Val(Trim(TempString))
Get #1, , TempString
EditorMap(r).NumberOfThings = Val(Trim(TempString))
For i = 1 To Val(EditorMap(r).NumberOfThings)
    Get #1, , TempString
    EditorMap(r).WhatsInIt(i) = Trim(TempString)
Next i
Get #1, , TempString
If Trim(TempString) <> "***" Then Exit For
Next r
Close #1
For i = -500 To 500
    For s = 1 To LevelNumber(i).NumberOfRooms
        LevelNumber(i).Rooms(s).NumberInMapArray = 0
        LevelNumber(i).Rooms(s).RoomName = ""
    Next s
    LevelNumber(i).NumberOfRooms = 0
Next i
For i = 1 To EditorNumberOfRooms
    LevelNumber(EditorMap(i).Level).NumberOfRooms = LevelNumber(EditorMap(i).Level).NumberOfRooms + 1
    LevelNumber(EditorMap(i).Level).Rooms(LevelNumber(EditorMap(i).Level).NumberOfRooms).NumberInMapArray = i
    LevelNumber(EditorMap(i).Level).Rooms(LevelNumber(EditorMap(i).Level).NumberOfRooms).RoomName = EditorMap(i).Name
Next i
End Sub
Function FindName(Name As String) As Integer
For z = 1 To EditorNumberOfRooms
    If EditorMap(z).Name = Name Then FindName = z: Exit Function
Next z
FindName = 0 'We Didnt Find It
End Function

Sub ValidateMap()
Dim FaultFound As Boolean
    For i = 1 To EditorNumberOfRooms
        If EditorMap(i).North = "None" And EditorMap(i).South = "None" And EditorMap(i).East = "None" And EditorMap(i).West = "None" And EditorMap(i).Up = "None" And EditorMap(i).Down = "None" Then
            MsgBox "Fatal Error : " & EditorMap(i).Name & " is not connected to any other rooms.", vbCritical, "Fatal Error"
            FaultFound = True
        End If
        If EditorMap(i).North <> "None" Then
        If FindName(EditorMap(i).North) = 0 Then
            FaultFound = True
            MsgBox "Could not find the room specified in the North Field for room " & EditorMap(i).Name & " on level " & EditorMap(i).Level, vbCritical, "Error in map"
        Else
            If EditorMap(FindName(EditorMap(i).North)).South <> EditorMap(i).Name Then
                FaultFound = True
                MsgBox "Error in South Field, in room " & EditorMap(i).North & " on level " & EditorMap(FindName(EditorMap(i).North)).Level, vbCritical, "Error in map"
            End If
        End If
        End If
        If EditorMap(i).South <> "None" Then
        If FindName(EditorMap(i).South) = 0 Then
            FaultFound = True
            MsgBox "Could not find the room specified in the South Field for room " & EditorMap(i).Name & " on level " & EditorMap(i).Level, vbCritical, "Error in map"
        Else
            If EditorMap(FindName(EditorMap(i).South)).North <> EditorMap(i).Name Then
                FaultFound = True
                MsgBox "Error in North Field, in room " & EditorMap(i).South & " on level " & EditorMap(FindName(EditorMap(i).South)).Level, vbCritical, "Error in map"
            End If
        End If
        End If
        If EditorMap(i).East <> "None" Then
        If FindName(EditorMap(i).East) = 0 Then
            FaultFound = True
            MsgBox "Could not find the room specified in the East Field for room " & EditorMap(i).Name & " on level " & EditorMap(i).Level, vbCritical, "Error in map"
        Else
            If EditorMap(FindName(EditorMap(i).East)).West <> EditorMap(i).Name Then
                FaultFound = True
                MsgBox "Error in West Field, in room " & EditorMap(i).East & " on level " & EditorMap(FindName(EditorMap(i).East)).Level, vbCritical, "Error in map"
            End If
        End If
        End If
        If EditorMap(i).West <> "None" Then
        If FindName(EditorMap(i).West) = 0 Then
            FaultFound = True
            MsgBox "Could not find the room specified in the West Field for room " & EditorMap(i).Name & " on level " & EditorMap(i).Level, vbCritical, "Error in map"
        Else
            If EditorMap(FindName(EditorMap(i).West)).East <> EditorMap(i).Name Then
                FaultFound = True
                MsgBox "Error in East Field, in room " & EditorMap(i).West & " on level " & EditorMap(FindName(EditorMap(i).West)).Level, vbCritical, "Error in map"
            End If
        End If
        End If
        If EditorMap(i).Up <> "None" Then
        If FindName(EditorMap(i).Up) = 0 Then
            FaultFound = True
            MsgBox "Could not find the room specified in the Up Field for room " & EditorMap(i).Name & " on level " & EditorMap(i).Level, vbCritical, "Error in map"
        Else
            If EditorMap(FindName(EditorMap(i).Up)).Down <> EditorMap(i).Name Then
                FaultFound = True
                MsgBox "Error in Down Field, in room " & EditorMap(i).Up & " on level " & EditorMap(FindName(EditorMap(i).Up)).Level, vbCritical, "Error in map"
            End If
        End If
        End If
        If EditorMap(i).Down <> "None" Then
        If FindName(EditorMap(i).Down) = 0 Then
            FaultFound = True
            MsgBox "Could not find the room specified in the Down Field for room " & EditorMap(i).Name & " on level " & EditorMap(i).Level, vbCritical, "Error in map"
        Else
            If EditorMap(FindName(EditorMap(i).Down)).Up <> EditorMap(i).Name Then
                FaultFound = True
                MsgBox "Error in Up Field, in room " & EditorMap(i).Down & " on level " & EditorMap(FindName(EditorMap(i).Down)).Level, vbCritical, "Error in map"
            End If
        End If
        End If
    Next i
    If FaultFound = True Then
        MsgBox "Map Failed Validation", vbInformation, "Failed"
        Validated = False
    Else
        MsgBox "Map Passed Validation", vbInformation, "Passed"
        Validated = True
    End If
End Sub
Sub SaveMap()
If Dir(App.Path & "\map.dat") <> "" Then Kill App.Path & "\map.dat"
Open App.Path & "\map.dat" For Binary As #1
TempString = EditorNumberOfRooms
Put #1, , TempString
For i = 1 To EditorNumberOfRooms
    TempString = EditorMap(i).Name
    Put #1, , TempString
    TempString = EditorMap(i).North
    Put #1, , TempString
    TempString = EditorMap(i).East
    Put #1, , TempString
    TempString = EditorMap(i).South
    Put #1, , TempString
    TempString = EditorMap(i).West
    Put #1, , TempString
    TempString = EditorMap(i).Up
    Put #1, , TempString
    TempString = EditorMap(i).Down
    Put #1, , TempString
    TempString = EditorMap(i).Level
    Put #1, , TempString
    TempString = EditorMap(i).NumberOfThings
    Put #1, , TempString
    For j = 1 To EditorMap(i).NumberOfThings
        TempString = EditorMap(i).WhatsInIt(j)
        Put #1, , TempString
    Next j
    TempString = "***"
    Put #1, , TempString
Next i
Close #1
End Sub
